package com.yice.webadmin.app.controller;

import com.github.pagehelper.page.PageMethod;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import com.yice.common.core.annotation.MyRequestBody;
import com.yice.common.core.constant.ErrorCodeEnum;
import com.yice.common.core.object.*;
import com.yice.common.core.util.MyCommonUtil;
import com.yice.common.core.util.MyModelUtil;
import com.yice.common.core.util.MyPageUtil;
import com.yice.common.log.annotation.OperationLog;
import com.yice.common.log.model.constant.SysOperationLogType;
import com.yice.webadmin.app.dto.ApiManageDto;
import com.yice.webadmin.app.model.ApiManage;
import com.yice.webadmin.app.service.ApiManageService;
import com.yice.webadmin.app.vo.ApiManageVo;
import io.swagger.annotations.Api;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 应用接入操作控制器类。
 *
 * @author linking
 * @date 2023-04-13
 */
@Api(tags = "应用接入管理接口")
@Slf4j
@RestController
@RequestMapping("/admin/app/apiManage")
public class ApiManageController {

    @Autowired
    private ApiManageService apiManageService;

    /**
     * 新增应用接入数据。
     *
     * @param apiManageDto 新增对象。
     * @return 应答结果对象，包含新增对象主键Id。
     */
    @ApiOperationSupport(ignoreParameters = {"apiManageDto.apiId"})
    @OperationLog(type = SysOperationLogType.ADD)
    @PostMapping("/add")
    public ResponseResult<Long> add(@MyRequestBody ApiManageDto apiManageDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(apiManageDto, false);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ApiManage apiManage = MyModelUtil.copyTo(apiManageDto, ApiManage.class);
        apiManage = apiManageService.saveNew(apiManage);
        return ResponseResult.success(apiManage.getApiId());
    }
    /**
     * 更新应用接入数据。
     *
     * @param apiManageDto 更新对象。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.UPDATE)
    @PostMapping("/update")
    public ResponseResult<Void> update(@MyRequestBody ApiManageDto apiManageDto) {
        String errorMessage = MyCommonUtil.getModelValidationError(apiManageDto, true);
        if (errorMessage != null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_VALIDATED_FAILED, errorMessage);
        }
        ApiManage apiManage = MyModelUtil.copyTo(apiManageDto, ApiManage.class);
        ApiManage originalApiManage = apiManageService.getById(apiManage.getApiId());
        if (originalApiManage == null) {
            // NOTE: 修改下面方括号中的话述
            errorMessage = "数据验证失败，当前 [数据] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        // 验证关联Id的数据合法性
        CallResult callResult = apiManageService.verifyRelatedData(apiManage, originalApiManage);
        if (!callResult.isSuccess()) {
            return ResponseResult.errorFrom(callResult);
        }
        if (!apiManageService.update(apiManage, originalApiManage)) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        return ResponseResult.success();
    }

    /**
     * 删除应用接入数据。
     *
     * @param apiId 删除对象主键Id。
     * @return 应答结果对象。
     */
    @OperationLog(type = SysOperationLogType.DELETE)
    @PostMapping("/delete")
    public ResponseResult<Void> delete(@MyRequestBody Long apiId) {
        if (MyCommonUtil.existBlankArgument(apiId)) {
            return ResponseResult.error(ErrorCodeEnum.ARGUMENT_NULL_EXIST);
        }
        return this.doDelete(apiId);
    }

    /**
     * 列出符合过滤条件的应用接入列表。
     *
     * @param apiManageDtoFilter 过滤对象。
     * @param orderParam           排序参数。
     * @param pageParam            分页参数。
     * @return 应答结果对象，包含查询结果集。
     */
    @PostMapping("/list")
    public ResponseResult<MyPageData<ApiManageVo>> list(
            @MyRequestBody ApiManageDto apiManageDtoFilter,
            @MyRequestBody MyOrderParam orderParam,
            @MyRequestBody MyPageParam pageParam) {
        if (pageParam != null) {
            PageMethod.startPage(pageParam.getPageNum(), pageParam.getPageSize());
        }
        ApiManage apiManageFilter = MyModelUtil.copyTo(apiManageDtoFilter, ApiManage.class);
        String orderBy = MyOrderParam.buildOrderBy(orderParam, ApiManage.class);
        List<ApiManage> apiManageList =
                apiManageService.getApiManageList(apiManageFilter, orderBy);
        return ResponseResult.success(MyPageUtil.makeResponseData(apiManageList, ApiManage.INSTANCE));
    }

    /**
     * 查看指定应用接入对象详情。
     *
     * @param apiId 指定对象主键Id。
     * @return 应答结果对象，包含对象详情。
     */
    @GetMapping("/view")
    public ResponseResult<ApiManageVo> view(@RequestParam Long apiId) {
        ApiManage apiManage = apiManageService.getByIdWithRelation(apiId, MyRelationParam.full());
        if (apiManage == null) {
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST);
        }
        ApiManageVo apiManageVo = ApiManage.INSTANCE.fromModel(apiManage);
        return ResponseResult.success(apiManageVo);
    }

    private ResponseResult<Void> doDelete(Long apiId) {
        String errorMessage;
        // 验证关联Id的数据合法性
        ApiManage originalApiManage = apiManageService.getById(apiId);
        if (originalApiManage == null) {
            errorMessage = "数据验证失败，当前 [对象] 并不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        if (!apiManageService.remove(apiId)) {
            errorMessage = "数据操作失败，删除的对象不存在，请刷新后重试！";
            return ResponseResult.error(ErrorCodeEnum.DATA_NOT_EXIST, errorMessage);
        }
        return ResponseResult.success();
    }
}
